<template>
  <div id="stud" v-bind:class="currentTheme">
    <input type="text" v-model="searchstr" class="uniinput"/> <button @click="changeTheme()"  class="uniinput">тема</button>
    <table v-bind:class="currentTheme">
      <tr
        v-for="item in students"
        v-bind:key="item._id"
        v-bind:class="
          item.name.includes(searchstr) && searchstr != '' ? 'highlight' : ''
        "
      >
        <td>
          <a
            href="#"
            @click="
              editId = item._id;
              preUpdate();
            "
            ><img class="pencil"
          /></a>
        </td>

        <td v-if="editId != item._id">
          <router-link v-bind:to="'/student-info/' + item._id">
            {{ item.name }}
          </router-link>
        </td>
        <td v-if="item._id == editId">
          <input type="text" v-model="studentToEdit.name" value="item.name" />
        </td>

        <td v-if="item._id == editId">
          <select v-model="studentToEdit.group" value="item.group" class="uniinput">
            <option>Группа 1</option>
            <option>Группа 2</option>
            <option>Группа 3</option>
          </select>
        </td>
        <td v-if="editId != item._id">{{ item.group }}</td>

        <td v-if="item._id == editId">
          <input type="checkbox" v-model="studentToEdit.isDonePr" class="uniinput"/>Пр
        </td>
        <td v-if="editId != item._id">
          <input type="checkbox" v-model="item.isDonePr" class="uniinput"/>Пр
        </td>

        <td><a href="#" @click.prevent="deleteStudent(item._id)" v-show="item.group==getCurrentUser.group">Удалить</a></td>
        <td v-if="item._id == editId">
          <a href="#" @click="updateStudent()">Обновить</a>
        </td>
      </tr>
    </table>
    <br />

    <input type="text" v-model="newstudent.name" class="uniinput"/>
    <select v-model="newstudent.group" class="uniinput">
      <option>Группа 1</option>
      <option>Группа 2</option>
      <option>Группа 3</option>
    </select>
    <input type="checkbox" v-model="newstudent.pr" class="uniinput"/>
    <button @click="addStudent()"  class="uniinput" >Добавить</button>
    <br><br>
    <router-link :to="'/converter/'"><button class="uniinput">Converter</button></router-link>
    <br>
    Количество студентов: {{getCount}}
  </div>
</template>

<script>
import Vue from "vue";
import img from "../pencil.png";

export default {
  data: function () {
    return {
      students: [],
      searchstr: "",
      editId: 0,
      currentTheme: "",
      studentToEdit: {
        _id: 0,
        name: "",
        group: "",
        pr: true,
      },
      newstudent: {
        name: "",
        group: "",
        pr: true,
      },
    };
  },
  mounted: async function () {
    console.log(this);
    let response = await this.axios.get("http://46.101.212.195:3000/students");
    this.students = response.data;
    this.$store.commit('setCount', this.students.length);
    
    console.log("vues theme:" + this.getTheme)
    if (this.getTheme){
    this.currentTheme = this.getTheme
    }
    else {
      this.currentTheme = "daytheme"; 
      this.$store.commit('setTheme', this.currentTheme)
    }
    
  },
  computed: {
    getCount() {
      return this.$store.getters.getCount
    },
    getTheme() {
      return this.$store.getters.getTheme 
    },
    getCurrentUser() {
      return this.$store.getters.getUser
    }
  },
  methods: {
    deleteStudent(studentid) {
      this.axios
        .delete("http://46.101.212.195:3000/students/" + studentid)
        .then((response) => {
          console.log(response.data);
        });
    },

    addStudent() {
      this.axios
        .post("http://46.101.212.195:3000/students", {
          name: this.newstudent.name,
          group: this.newstudent.group,
          isDonePr: this.newstudent.isDonePr,
        })
        .then((response) => {
          console.log(response.data);
        });
    },

    preUpdate() {
      this.studentToEdit = this.students.find(
        (item) => item._id == this.editId
      );
    },

    updateStudent() {
      this.students.map((item) =>
        item._id === this.editId
          ? {
              name: this.studentToEdit.name,
              group: this.studentToEdit.group,
              isDonePr: this.studentToEdit.isDonePr,
            }
          : item
      );
      this.axios
        .put("http://46.101.212.195:3000/students/" + this.editId, {
          name: this.studentToEdit.name,
          group: this.studentToEdit.group,
          isDonePr: this.studentToEdit.isDonePr,
        })
        .then((response) => {
          console.log(response.data);
          this.editId = 0;
        });
    },

    changeTheme() {
      if (this.currentTheme=='daytheme') {
        this.currentTheme = 'nighttheme';
        this.$store.commit('setTheme', this.currentTheme);
      }
      else if (this.currentTheme == 'nighttheme') {
        this.currentTheme = 'daytheme';
        this.$store.commit('setTheme', this.currentTheme);
      }
    }
  },
};
</script>
<style scoped>
.pencil {
  background-image: url(../pencil.png);
  width: 20px;
  height: 20px;
  background-size: 100%;
}
.daytheme {
    background-color: rgb(255, 254, 240);
    font-family: 'Sitka small' ;
    font-weight: 700;
    color: rgb(83, 65, 141);
    transition: 300ms;

     border-radius: 10px;
    border:none;
}

.nighttheme {
    background-color:rgb(83, 65, 141);
    font-family: 'Sitka small' ;
    font-weight: 700;
    color:rgb(255, 254, 240); 
    transition: 300ms;
}

.uniinput{
    background-color: rgb(212, 184, 153);
    font-family: 'Sitka small' ;
    font-weight: 700;
    color: rgb(83, 65, 141);
    padding: 5px 10px 5px 10px;
    border-radius: 10px;
    border:none;
}

</style>